# Looking for a Professional React UI Library?

This package helps you to use [Kendo UI for jQuery](https://demos.telerik.com/kendo-ui/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-all-wrapper&utm_content=description) in React applications. It should not be confused with the [KendoReact All](https://www.npmjs.com/package/@progress/kendo-react-all), which is written 100% with React (no jQuery dependency).

Most UI components in Kendo UI for jQuery have their native React equivalents, available as part of the [KendoReact UI library](https://www.telerik.com/kendo-react-ui/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-all-wrapper).

## Important

This package will not be receiving future updates. We strongly encourage you to work with the native React implementation linked above.
If you still need to use the Kendo UI for jQuery widgets in your React applications, you can follow [these instructions](https://docs.telerik.com/kendo-ui/third-party/react?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-all-wrapper).

## What is the Difference between Kendo UI for jQuery and KendoReact?

[Kendo UI for jQuery](https://www.telerik.com/kendo-jquery-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-all-wrapper&utm_content=description) is a complete, feature-rich jQuery UI component library.

The [KendoReact All](https://www.telerik.com/kendo-react-ui/components/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-all-wrapper&utm_content=description) package is part of [KendoReact](https://www.telerik.com/kendo-react-ui/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-all-wrapper&utm_content=description), a library that includes 100+ UI and DataViz components designed and built from the ground up for React.

*Copyright © 2021 Progress Software Corporation and/or its subsidiaries or affiliates. All Rights Reserved.*

*Progress, Kendo UI, KendoReact and associated product names used herein are trademarks or registered trademarks of Progress Software Corporation and/or one of its subsidiaries or affiliates in the U.S. and/or other countries.*
