/// <reference types="@progress/kendo-ui" />
import * as React from 'react';
export interface KendoWidgetProps {
    widgetRef?(widget: kendo.ui.Widget): void;
}
declare class KendoBaseComponent<P extends KendoWidgetProps, S = {}> extends React.PureComponent<P, {}> {
    destroyed: boolean;
    widgetInstance: kendo.ui.Widget;
    widgetDestroy: Function;
    protected didMount: boolean;
    protected domNode: HTMLElement | null;
    componentDidMount(): void;
    componentWillUnmount(): void;
    protected elementRef: (el: HTMLElement) => void;
    private exposeWidget;
    private overrideDestroy;
}
export default KendoBaseComponent;
